Subject: Re: bug#21695: 25.0.50; Change most occurrences of `setq' in Emacs manual to `customize-set-variable'? Really?

From: Gregory Heytings <[email-masked]>
Date: Fri, 10 Sep 2021 14:26:35 +0000

>> Then I still don't get what you mean.  An autoloaded but not yet loaded 
>> variable doesn't have its custom-set property set, so in that case 
>> there would be no warning with the proposed patch.  Warnings are 
>> displayed only for customs variables that are "fully" loaded, and who 
>> have a :set property.
>
> Doesn't ;;;###autoload pull the entire defcustom form into loaddefs.el?
>
> But I see that we autoload basically no defcustoms (five, apparently), 
> so I guess it's a moot point.
>

One of them is allout-auto-activation.  To see that autoloaded variables 
do not have a custom-set property until they are actually loaded, you can 
use:

(defmacro check (sym)
   `(when (get ,sym 'custom-set)
      (display-warning 'setq (format "`%s' should be set with `customize-set-variable'" ,sym))))
(check 'allout-auto-activation)
(load "allout")
(check 'allout-auto-activation)